using CtrlAltAssist.Components;
using CtrlAltAssist.Services;
using Microsoft.AspNetCore.Components.Forms;
using Microsoft.AspNetCore.Identity.UI.Services;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddRazorComponents()
    .AddInteractiveServerComponents();

builder.Services.AddHttpClient();

/*
builder.Services.AddScoped(sp =>
{
    var httpClient = new HttpClient() { BaseAddress = new Uri(builder.Host.HostEnvironment.BaseAddress) };

    var Antiforgery = sp.GetRequiredService<AntiforgeryStateProvider>();
    httpClient.DefaultRequestHeaders.Add("RequestVerificationToken", Antiforgery.GetAntiforgeryToken().Value);

    return httpClient;
});
*/

builder.Services.AddSingleton<IEmailSender, EmailSender>();

var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error", createScopeForErrors: true);
    // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
    app.UseHsts();
}
app.UseStatusCodePagesWithReExecute("/not-found", createScopeForStatusCodePages: true);
app.UseHttpsRedirection();

app.UseAntiforgery();

app.MapStaticAssets();
app.MapRazorComponents<App>()
    .AddInteractiveServerRenderMode();

app.Run();
